/*
 * SeedResolver.h 汾2.0
 * 
 * ߣbluekitty(һ) @ CSDN 2012-01
 * 
 * ˵
 * ͷļ CSeedResolverڽBTļļȫbencodeֽڴļ
 * bencode뷽ʽļĹؼֲοhttp://wiki.theory.org/BitTorrentSpecification
 * ļһbencodeֵ䣬ؼ֣԰һļһṹ
 * ȻݹǽļȽֱӵķ
 * 
 * ˵
 * ԴĿ¼STLĿ¼ CSeedResolver һʵ֣ʹñ׼mapvectorݳΪ1.0棬
 * 1.02.0湦ܻһ1.0ĳЩ⡣
 * bencodeĶ壬뵽ľʹñ׼mapʵbencodeֵ䣬vectorʵbencodeб
 * ʵʲԷ֣
 * mapֱӱڵ㣨ΪNode󣬻ǳڴ棬һ6000ļʱʹڴ
 * 70MңҪƶͲȻmapĲŻٶȷǳ죬дʱȻ
 * Եʱ俪ܴ󣬻Ǹ6000ļӣҪ14ҡ
 * mapһڵָ룬ȻٶȺڴĶкܴĸƣڴܲͷţ
 * һļʱȻڴй©ˮƽޣҲûҵİ취Ҳmapallocator
 * Խڴͷŵ⣬ʵǶstlڴǺϤԽڴͷŵ⣬ôʹ
 * ׼⻹ǲģһǴȽ׶Ǳ׼зḻ㷨û׼Ժõõڱò
 * ֻǶȡӵϢǶļݴ
 * 
 */

#pragma once

#include <vector>

#define SAFE_CLEAN(p) if(p) delete p;p = NULL;
#define SAFE_RETURN(p, ret) { SAFE_CLEAN(p);return ret; }

/* bencodeǰ׺stringķָ */
#define BC_PREFIX_INT			'i'
#define BC_PREFIX_LIST			'l'
#define BC_PREFIX_DICT			'd'
#define BC_SUFFIX				'e'
#define BC_STRING_DELIMITER		':'

/* BitCometǶļǰ׺Щļ */
#define BITCOMET_PADDING_FILE_PREFIX "_____padding_file"

/* ļĹؼ֣ļһbencodeֵֵͣĹؼ֣ر˵еֵַutf-8
 * һЩؼ֣Ĺؼбο˵http://wiki.theory.org/BitTorrentSpecification ǶЩؼҲǶõõ*/
#define KEYWORD_ANNOUNCE		"announce"		//bencodeַtrackerurlݹٷͣannounce-listؼӦúؼ

#define KEYWORD_ANNOUNCE_LIST	"announce-list"	//bencodeббǱҪؼ֣trackerбannounce-listбǶбÿбһurlַ

#define KEYWORD_CREATION_DATE	"creation date"	//bencodeǱҪؼ֣ӵĴʱ,1970-1-1 00:00:00 UTC 

#define KEYWORD_COMMENT			"comment"		//bencodeַǱҪؼ֣ӵıע

#define KEYWORD_COMMENT_UTF8	"comment.utf-8"	//bencodeַ,ؼҴӹٷ鲻BitCometչĹؼ֣ؼ־ͺǸΪһUTF-8

#define KEYWORD_CREATED_BY		"created by"	//bencodeַǱҪؼ֣ļ汾ʽ uTorrent/183BʾuTorrent 183B洴

#define KEYWORD_ENCODING		"encoding"		/*bencodeַǱҪؼ֣ٷļinfoֵpiecesεַʹõı뷽ʽ
												 *ʵʷָôı뷽ʽͬӰinfoֵڵַ֪ʲô */

#define KEYWORD_PUBLISHER		"publisher"		//bencodeַӵķߣؼҴӹٷҲ鲻publisher-urlؼ

#define KEYWORD_PUBLISHER_UTF8	"publisher.utf-8"//ͬKEYWORD_COMMENT_UTF8

#define KEYWORD_INFO			"info"			//bencodeֵ䣬ڵļ忴˵http://wiki.theory.org/BitTorrentSpecification

/* ЩؼinfoֵĹؼ */
#define KEYWORD_INFO_PIECE_LENGTH	"piece length"	/* bencodeÿһĳȣλֽڣٷ524288512kֽڣвͬ*/

#define KEYWORD_INFO_PIECES			"pieces"		/* bencodeַÿӴֵSHA1̶20ֽڳϣܺܳ
													 * ٷ˵byte string, i.e. not urlencodedȻĳȱ20ıҲͨ
													 * ĳȳ20һжٿ顣
													 * ע⣬ַǱ׼cַκλönullַַڸַ */

#define KEYWORD_INFO_PRIVATE		"private"		/* bencodeǱҪؼ֣ʵԿһBOOLΪ1ʱʾֻͨڵķõpeers
													 * Ϊ0δʱԴⲿpeersDHT */

/* ¹ؼǺļصģ忴˵http://wiki.theory.org/BitTorrentSpecification */
#define KEYWORD_NAME		"name"//ļģʽļļģʽǽԵļĿ¼
#define KEYWORD_NAME_UTF8	"name.utf-8"//ͬKEYWORD_COMMENT_UTF8
#define KEYWORD_FILES		"files"//ļб
#define KEYWORD_PATH		"path"//һбһļǰĿ¼
#define KEYWORD_PATH_UTF8	"path.utf-8"//ͬKEYWORD_COMMENT_UTF8
#define KEYWORD_LENGTH		"length"//ļ

/* bencode */
enum BC_TYPE_NAME { BC_STRING, BC_INT, BC_LIST, BC_DICT };

struct _Node;//Ľڵ

/* bencode */
typedef char*			BC_String;
typedef DWORDLONG		BC_Int;
typedef struct _Node*	BC_List, **LPBC_List;
typedef struct _BC_Dict
{
	char* pszKey;
	struct _Node* pNode;
} BC_Dict, *LPBC_Dict;


/* ڵ㶨壬һڵĶ岻һο
 * BC_DictBC_Listʵһݹ鶨 */
typedef struct _Node
{
	UINT Type;

	union
	{
		BC_String	bcString;
		BC_Int		bcInt;
		LPBC_List	bcList;
		LPBC_Dict	bcDict;
	} Data;

} Node, *LPNode;

/* ڵļ */
typedef struct _Inner_File
{
	/* · */
	CString PathName;

	/* ļ */
	CString FileName;

	/* ļСλֽ */
	DWORDLONG FileSize;

	/* ļͣļֱṩԼBT FileResolverView.cppļжGetFileInfo */
	CString FileType;

	_Inner_File() { FileSize = 0; }
} InnerFile, *PInnerFile;

/* ṹҪõݣڵò
 * ʵ̻ŻֱҪݣûʵ֣
 * һԺпõԻǱȫ */
typedef struct _Values_Needed
{
	CString Seed_FileName;
	CString Seed_CreationDate;
	CString Seed_Comment;
	CString Seed_Creator;
	CString Seed_Publisher;
	int		Seed_Encoding;//CodePage

	std::vector<InnerFile> Seed_Files;//ļб
} Values_Needed;

class CSeedResolver
{
private:
	UINT m_SeedFileSize;//ļĴС
	UINT m_Position;//ǰָļλ
	
	/* mallocreallocָ룬ʱͷЩָ룬
	 * ݹļʱڴķ䶼ʹmallocrealloc
	 * ͳһͷţĻǶʹnew䣬ʹ
	 * SAFE_CLEANSAFE_RETURNͷ */
	std::vector<INT_PTR> vecAllocated;

	/* ǷԽ(ļΧ) */
	BOOL IsRangeValid(UINT nOffset = 0);

	/* ȡһbencodeַ(׼cַ) */
	char* GetBCString(char** pBuffer);

	/* ȡһbencode */
	DWORDLONG GetBCInt(char** pBuffer);

	/* ָĻǸݹ麯 */
	LPNode ResovleBuffer(char** pBuffer);

	/* pDictõһָؼֵĽڵ㣨LPNode*ֵΪùؼǷ
	 * ܽpDictΪconstΪҪƶpDictָ */
	BOOL GetNode(LPBC_Dict pDict, const char* pszKey, _Out_ LPNode* pNode);

	/* ͷŽзڴ */
	void DeallocAll();

	/* ׼cַ -> UnicodenCodePage = 0ʾʹڶĴҳ */
	void ConvertToUnicode( const char* pStr ,CString& s, int nCodePage = 0);

public:
	Values_Needed SeedInfo;

	CSeedResolver(const CString& SeedFileName);
	~CSeedResolver(void);

	/* ȵøúݷֵȷǷɹ */
	BOOL Resolve();

};
